<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Quiz-5</title>
</head>

<body>

  <div id="app">

      <div class="formInput">
        <!-- <input type="text" v-bind:value="formUser" @input="formUser = $event.target.value"> -->
        <input type="text" v-model="formUser">
        <button @click="addUser" v-if="!buttonEditStatus">Add</button>
        <button @click="updateUser" v-if="buttonEditStatus">Update</button>
      </div>

      <div class="userList">
        <ul v-for="(user , index ) in reverseUsers"> <!-- fungsi looping -->
          <li :key="index">
              {{ user.name }} ||
              <button @click="editUser(index)">Edit</button>
              <button @click="deleteUser(index)">Delete</button>
          </li>
        </ul>
      </div>
    
  </div>

  <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>

  <script>
    let vm = new Vue({
      el: "#app",
      data: {
        users : [
           { name : 'Muhammad Doni Saputra'},
           { name : 'Siti Fatimah'},
           { name : 'Zainab'}
        ],
        formUser : '',
        buttonEditStatus : false,
        idSelected : null
      },

      //Ngereverse User
      computed:{
          reverseUsers :{
            get : function(){
              return this.users.slice().reverse()
            },
            set : function(value){
              this.users = value.slice().reverse()
            }
          }
      },

      //Menambah User
      methods:{
        addUser : function(){
          this.users.push(
            { name : this.formUser }
          )

          //mengosongkan form addUser setelah menambahkan user
          this.formUser = ''
        },
        editUser : function(id){
            this.formUser = this.reverseUsers[id].name
            this.buttonEditStatus = true
            this.idSelected   = id
        },
        updateUser : function(){
            this.reverseUsers[this.idSelected].name = this.formUser
            this.formUser = ''
            this.buttonEditStatus = false 
        },
        deleteUser : function(id){
            let confirmation = confirm ("Apakah anda yakin?")

            if(confirmation){
              this.reverseUsers = this.reverseUsers.filter(function(item, index){
                return index != id

              })

            }
        }
      }
    })
  </script>

</body>

</html>